"""
    DataTask <: AbstractDataTask

Task representing a specific data transfer in the ABC Model.
"""
struct DataTask <: AbstractDataTask
    data::UInt64
end

"""
    ComputeTaskS1 <: AbstractComputeTask

S task with a single child.
"""
struct ComputeTaskS1 <: AbstractComputeTask end

"""
    ComputeTaskS2 <: AbstractComputeTask

S task with two children.
"""
struct ComputeTaskS2 <: AbstractComputeTask end

"""
    ComputeTaskP <: AbstractComputeTask

P task with no children.
"""
struct ComputeTaskP <: AbstractComputeTask end

"""
    ComputeTaskV <: AbstractComputeTask

v task with two children.
"""
struct ComputeTaskV <: AbstractComputeTask end

"""
    ComputeTaskU <: AbstractComputeTask

u task with a single child.
"""
struct ComputeTaskU <: AbstractComputeTask end

"""
    ComputeTaskSum <: AbstractComputeTask

Task that sums all its inputs, n children.
"""
mutable struct ComputeTaskSum <: AbstractComputeTask
    children_number::Int
end

"""
    ABC_TASKS

Constant vector of all tasks of the ABC-Model.
"""
ABC_TASKS = [DataTask, ComputeTaskS1, ComputeTaskS2, ComputeTaskP, ComputeTaskV, ComputeTaskU, ComputeTaskSum]
