# function to return the possible operations of a graph

using Base.Threads

"""
    get_operations(graph::DAG)

Return the [`PossibleOperations`](@ref) of the graph at the current state.
"""
function get_operations(graph::DAG)
    apply_all!(graph)

    if isempty(graph.possibleOperations)
        generate_operations(graph)
    end

    for node in graph.dirtyNodes
        clean_node!(graph, node)
    end
    empty!(graph.dirtyNodes)

    return graph.possibleOperations
end
